
#include "config.h"

#define LED PORTB.3

unsigned int  IR_BTemp; //  ""
unsigned char TOV_Count; //  ( < 10   , 10 -    )
unsigned char Rep_Count=0; //    (   )

unsigned char Lo_Ref; // ""
unsigned char Hi_Ref; // ""
unsigned char CNT; //   Timer0.   IR 
unsigned char Frame_Pos; //   

bit F_Data_Out = 0;
bit F_Key_Pressed;
bit Set_Key=0;

unsigned char Get_CNT()
{
    unsigned char CurCNT = CNT;
    CNT = 0;
    #asm("WDR")
    return CurCNT;
}

void Key_Down()
{
    F_Key_Pressed = 1;
    LED = 1; // 
    TOV_Count = 0;   
    TCCR0B=0x01;//0x02;     
}

void Key_Up()
{
    F_Key_Pressed = 0;
    LED = 0;    
    TCCR0B=0x00;
}

#if PROG_ON==1
eeprom unsigned int key[5];//   eeprom

void Led_Blink(char n, char mod)
{
 n<<=1;
 for(;n;n--)
  { 
   if(mod==1)delay_ms(100);
   else delay_ms(200); 
   LED ^= 1; 
  }
 LED = 0;  
}

void f_set_key(void)
{
 char i;
       
 Led_Blink(20, 1);  
  
 F_Data_Out=0; 
 Frame_Pos = 0; 
  
 for(i=0;i<5;i++)
  {
     while(F_Data_Out == 0);  
     
     F_Data_Out=0;
     key[i]= IR_BTemp; 
     
     Led_Blink(i+1, 1); 
     Frame_Pos = 0;  
  }  
  
 Led_Blink(10, 2);
}

void f_set_pin(void)
{
 unsigned char i;    

 for(i=0;i<5;i++)
  {
   if(IR_BTemp==key[i])
    {  
     switch(i)
      {
       case 0: PORTB.4^=1; break; //  A
       case 1: PORTB.2^=1; break; //  B
       case 2: PORTB.0^=1; break; //  C   
       
       case 3://    A,B,C
         {  
          
          PORTB.4=1; 
          PORTB.2=1;
          PORTB.0=1;
           
         }break;  
         
       case 4://  A,B,C
         {     
          PORTB.4=0; 
          PORTB.2=0;
          PORTB.0=0; 
         }break;    
         
          
      }//switch(i)  
      
     break; 
    }
  }
}
#endif

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
 unsigned char CurCNT = Get_CNT(); //     
   
 switch(Frame_Pos)  
  {
   case 0:
    { 
     Key_Down(); 
     Frame_Pos++;  
    }break;
     
   case 4:
    {
     //  
     Hi_Ref = CurCNT + (CurCNT >> 2); //   +1/4
     Lo_Ref = CurCNT - (CurCNT >> 2); //    -1/4
     IR_BTemp = 0; //!!!  
        //     
     Frame_Pos=255;        
    }break;   
    
   case 255:
    {//   
     IR_BTemp <<=1;
     if (CurCNT > Hi_Ref | CurCNT < Lo_Ref) IR_BTemp |= 1; //    - "1"    
    }break;  
    
   default:Frame_Pos++; 
  }         
}

// Timer 0 output compare A interrupt service routine
//interrupt [TIM0_COMPA] void timer0_compa_isr(void)
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
 CNT++;  //   
}

// Watchdog timeout interrupt service routine
interrupt [WDT] void wdt_timeout_isr(void)
{
 WDTCR=0x48;        
  
 if(TOV_Count++ > 50)Rep_Count=0;  
    
 if (F_Key_Pressed != 0)//     Key_Up()
  {  
   if (TOV_Count > 10 ) 
    {    
     Key_Up(); //    (  )
     if (Frame_Pos != 0)
      {
    //  
    //   
       LED = 0; //  
       if (Frame_Pos == 255)
       { 
        F_Data_Out = 1; // -   UART
        if(Rep_Count++ > 10)Set_Key=1; // -   
       }
       else  Frame_Pos = 0;
      }
    }            
  }
}

// Declare your global variables here

void main(void){
// Input/Output Ports initialization
// Port B initialization

PORTB= 0b00100000;
DDRB=  0b00111101;   //0x18;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1200,000 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
//TCCR0B=0x01;//0x02;
TCNT0=0x00;
OCR0A=0x7C;
OCR0B=0x00;

/*
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1200,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x02;
TCCR0B=0x00;//0x02;
TCNT0=0x00;
OCR0A=0x0c;
OCR0B=0x00;
*/
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x40;
GIFR=0x40;
MCUCR=0x02;// 
//MCUCR=0x01;//   

// Timer/Counter 0 Interrupt(s) initialization
//TIMSK0=0x04; //  compare A interrupt
TIMSK0=0x02;  //overflow interrupt

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2k
// Watchdog Timer interrupt: On
#pragma optsize-
WDTCR=0x18;
WDTCR=0xC8;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

Frame_Pos = 0;
TOV_Count = 0;

// Global enable interrupts
#asm("sei")
LED = 1;
delay_ms(120);
LED = 0;

#if UART_ON == 1 
stx_init(); //  UART'
stx_char('O');
stx_char('K');
stx_char('!');
#endif

while(1)
    {   
       //stx_char('*');       
#if PROG_ON==1
        if(Set_Key!=0)// 
         {  
          Set_Key=0;  
          Rep_Count=0;
          f_set_key();
         }  
#endif         
        if (F_Data_Out != 0)//  
         {  
          #if UART_ON == 1     
          stx_char('*');        
          stx_char(IR_BTemp>>8);
          stx_char(IR_BTemp);            
          //stx_char(Rep_Count);
          #endif
          
#if PROG_ON==1  
          f_set_pin();
#endif
        
          F_Data_Out = 0; 
          Frame_Pos = 0; 
         }
    }
}