
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; 
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

extern void stx_char(unsigned char value);

unsigned int  IR_BTemp; 
unsigned char TOV_Count; 
unsigned char Rep_Count=0; 

unsigned char Lo_Ref; 
unsigned char Hi_Ref; 
unsigned char CNT; 
unsigned char Frame_Pos; 

bit F_Data_Out = 0;
bit F_Key_Pressed;
bit Set_Key=0;

unsigned char Get_CNT()
{
unsigned char CurCNT = CNT;
CNT = 0;
#asm("WDR")
return CurCNT;
}

void Key_Down()
{
F_Key_Pressed = 1;
PORTB.3 = 1; 
TOV_Count = 0;   
TCCR0B=0x01;
}

void Key_Up()
{
F_Key_Pressed = 0;
PORTB.3 = 0;    
TCCR0B=0x00;
}

eeprom unsigned int key[5];

void Led_Blink(char n, char mod)
{
n<<=1;
for(;n;n--)
{ 
if(mod==1)delay_ms(100);
else delay_ms(200); 
PORTB.3 ^= 1; 
}
PORTB.3 = 0;  
}

void f_set_key(void)
{
char i;

Led_Blink(20, 1);  

F_Data_Out=0; 
Frame_Pos = 0; 

for(i=0;i<5;i++)
{
while(F_Data_Out == 0);  

F_Data_Out=0;
key[i]= IR_BTemp; 

Led_Blink(i+1, 1); 
Frame_Pos = 0;  
}  

Led_Blink(10, 2);
}

void f_set_pin(void)
{
unsigned char i;    

for(i=0;i<5;i++)
{
if(IR_BTemp==key[i])
{  
switch(i)
{
case 0: PORTB.4^=1; break; 
case 1: PORTB.2^=1; break; 
case 2: PORTB.0^=1; break; 

case 3:
{  

PORTB.4=1; 
PORTB.2=1;
PORTB.0=1;

}break;  

case 4:
{     
PORTB.4=0; 
PORTB.2=0;
PORTB.0=0; 
}break;    

}

break; 
}
}
}

interrupt [2] void ext_int0_isr(void)
{
unsigned char CurCNT = Get_CNT(); 

switch(Frame_Pos)  
{
case 0:
{ 
Key_Down(); 
Frame_Pos++;  
}break;

case 4:
{

Hi_Ref = CurCNT + (CurCNT >> 2); 
Lo_Ref = CurCNT - (CurCNT >> 2); 
IR_BTemp = 0; 

Frame_Pos=255;        
}break;   

case 255:
{
IR_BTemp <<=1;
if (CurCNT > Hi_Ref | CurCNT < Lo_Ref) IR_BTemp |= 1; 
}break;  

default:Frame_Pos++; 
}         
}

interrupt [4] void timer0_ovf_isr(void)
{
CNT++;  
}

interrupt [9] void wdt_timeout_isr(void)
{
WDTCR=0x48;        

if(TOV_Count++ > 50)Rep_Count=0;  

if (F_Key_Pressed != 0)
{  
if (TOV_Count > 10 ) 
{    
Key_Up(); 
if (Frame_Pos != 0)
{

PORTB.3 = 0; 
if (Frame_Pos == 255)
{ 
F_Data_Out = 1; 
if(Rep_Count++ > 10)Set_Key=1; 
}
else  Frame_Pos = 0;
}
}            
}
}

void main(void){

PORTB= 0b00100000;
DDRB=  0b00111101;   

TCCR0A=0x00;

TCNT0=0x00;
OCR0A=0x7C;
OCR0B=0x00;

GIMSK=0x40;
GIFR=0x40;
MCUCR=0x02;

TIMSK0=0x02;  

#pragma optsize-
WDTCR=0x18;
WDTCR=0xC8;
#pragma optsize+

Frame_Pos = 0;
TOV_Count = 0;

#asm("sei")
PORTB.3 = 1;
delay_ms(120);
PORTB.3 = 0;

{PORTB |=  (1<<4);                             DDRB  |= (1<<4);}; 
stx_char('O');
stx_char('K');
stx_char('!');

while(1)
{   

if(Set_Key!=0)
{  
Set_Key=0;  
Rep_Count=0;
f_set_key();
}  
if (F_Data_Out != 0)
{  
stx_char('*');        
stx_char(IR_BTemp>>8);
stx_char(IR_BTemp);            

f_set_pin();

F_Data_Out = 0; 
Frame_Pos = 0; 
}
}
}
