/**
  Simple TX -       RS-232

  : CodeVisionAVR.

  void stx_init()                    -     (  )
  void stx_char(unsigned char value) -  
*/
#ifndef __STX_H
#define __STX_H

#include <delay.h>
#define stx_delay(x)      delay_us(1000000/STX_BAUDRATE - x/(_MCU_CLOCK_FREQUENCY_/1000000))

/*      */
#ifndef STX_PORT_NAME
#error    STX_PORT_NAME  __  (B)
#endif

#ifndef STX_PIN
#error    STX_PIN   
#endif

#ifndef STX_BAUDRATE
#error    STX_BAUDRATE ( )
#endif

/*          */
#define STX_CONCAT(a,b)     a ## b
#define STX_CONCAT_EX(a,b)  STX_CONCAT(a,b)
#define stx_pin_on()        STX_CONCAT_EX(PORT,STX_PORT_NAME) |=  (1<<STX_PIN)
#define stx_pin_off()       STX_CONCAT_EX(PORT,STX_PORT_NAME) &= ~(1<<STX_PIN)

#define stx_init()          {stx_pin_on();\
                             STX_CONCAT_EX(DDR,STX_PORT_NAME)  |= (1<<STX_PIN);}

extern void stx_char(unsigned char value);
#endif
