
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny13
;Program type             : Application
;Clock frequency          : 9,600000 MHz
;Memory model             : Tiny
;Optimize for             : Size
;(s)printf features       : int
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 20 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Smart register allocation     : Off
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny13
	#pragma AVRPART MEMORY PROG_FLASH 1024
	#pragma AVRPART MEMORY EEPROM 64
	#pragma AVRPART MEMORY INT_SRAM SIZE 64
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _IR_BTemp=R4
	.DEF _TOV_Count=R6
	.DEF _Rep_Count=R7
	.DEF _Lo_Ref=R8
	.DEF _Hi_Ref=R9
	.DEF _CNT=R10
	.DEF _Frame_Pos=R11

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _wdt_timeout_isr
	RJMP 0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x20052:
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  0x07
	.DW  _0x20052*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x40)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x9F)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x74)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x74

	.CSEG
;/**
; Simple TX -       RS-232
;
;  stx.h
;
;
;*/
;
;#include "config.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#if UART_ON == 1
;
;#include "stx.h"
;
;void stx_char(unsigned char value)
; 0000 0010 {

	.CSEG
_stx_char:
; 0000 0011  volatile unsigned char i = 1;
; 0000 0012  stx_pin_off();                                         //  
	SBIW R28,1
	LDI  R30,LOW(1)
	ST   Y,R30
;	value -> Y+1
;	i -> Y+0
	CBI  0x18,4
; 0000 0013  stx_delay(20);
	RCALL SUBOPT_0x0
; 0000 0014  while(i)
_0x3:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x5
; 0000 0015   {
; 0000 0016    if(value & i) stx_pin_on();
	LDD  R26,Y+1
	AND  R30,R26
	BREQ _0x6
	SBI  0x18,4
; 0000 0017    else stx_pin_off();
	RJMP _0x7
_0x6:
	CBI  0x18,4
; 0000 0018 
; 0000 0019    i <<= 1;
_0x7:
	LD   R30,Y
	LSL  R30
	ST   Y,R30
; 0000 001A    stx_delay(20);
	RCALL SUBOPT_0x0
; 0000 001B   }
	RJMP _0x3
_0x5:
; 0000 001C  stx_pin_on();                                          //   
	SBI  0x18,4
; 0000 001D  stx_delay(20);
	RCALL SUBOPT_0x0
; 0000 001E }
	RJMP _0x2000002
;
;#endif
;
;#include "config.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#define LED PORTB.3
;
;unsigned int  IR_BTemp; //  ""
;unsigned char TOV_Count; //  ( < 10   , 10 -    )
;unsigned char Rep_Count=0; //    (   )
;
;unsigned char Lo_Ref; // ""
;unsigned char Hi_Ref; // ""
;unsigned char CNT; //   Timer0.   IR 
;unsigned char Frame_Pos; //   
;
;bit F_Data_Out = 0;
;bit F_Key_Pressed;
;bit Set_Key=0;
;
;unsigned char Get_CNT()
; 0001 0014 {

	.CSEG
_Get_CNT:
; 0001 0015     unsigned char CurCNT = CNT;
; 0001 0016     CNT = 0;
	ST   -Y,R16
;	CurCNT -> R16
	MOV  R16,R10
	CLR  R10
; 0001 0017     #asm("WDR")
	WDR
; 0001 0018     return CurCNT;
	MOV  R30,R16
	RJMP _0x2000001
; 0001 0019 }
;
;void Key_Down()
; 0001 001C {
_Key_Down:
; 0001 001D     F_Key_Pressed = 1;
	SET
	BLD  R2,1
; 0001 001E     LED = 1; // 
	SBI  0x18,3
; 0001 001F     TOV_Count = 0;
	CLR  R6
; 0001 0020     TCCR0B=0x01;//0x02;
	LDI  R30,LOW(1)
	RJMP _0x2000003
; 0001 0021 }
;
;void Key_Up()
; 0001 0024 {
_Key_Up:
; 0001 0025     F_Key_Pressed = 0;
	CLT
	BLD  R2,1
; 0001 0026     LED = 0;
	CBI  0x18,3
; 0001 0027     TCCR0B=0x00;
	LDI  R30,LOW(0)
_0x2000003:
	OUT  0x33,R30
; 0001 0028 }
	RET
;
;#if PROG_ON==1
;eeprom unsigned int key[5];//   eeprom
;
;void Led_Blink(char n, char mod)
; 0001 002E {
_Led_Blink:
; 0001 002F  n<<=1;
;	n -> Y+1
;	mod -> Y+0
	LDD  R30,Y+1
	LSL  R30
	STD  Y+1,R30
; 0001 0030  for(;n;n--)
_0x20008:
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x20009
; 0001 0031   {
; 0001 0032    if(mod==1)delay_ms(100);
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x2000A
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RJMP _0x2004F
; 0001 0033    else delay_ms(200);
_0x2000A:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
_0x2004F:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0001 0034    LED ^= 1;
	LDI  R26,0
	SBIC 0x18,3
	LDI  R26,1
	RCALL SUBOPT_0x1
	BRNE _0x2000C
	CBI  0x18,3
	RJMP _0x2000D
_0x2000C:
	SBI  0x18,3
_0x2000D:
; 0001 0035   }
	LDD  R30,Y+1
	SUBI R30,LOW(1)
	STD  Y+1,R30
	RJMP _0x20008
_0x20009:
; 0001 0036  LED = 0;
	CBI  0x18,3
; 0001 0037 }
_0x2000002:
	ADIW R28,2
	RET
;
;void f_set_key(void)
; 0001 003A {
_f_set_key:
; 0001 003B  char i;
; 0001 003C 
; 0001 003D  Led_Blink(20, 1);
	ST   -Y,R16
;	i -> R16
	LDI  R30,LOW(20)
	RCALL SUBOPT_0x2
; 0001 003E 
; 0001 003F  F_Data_Out=0;
	CLT
	BLD  R2,0
; 0001 0040  Frame_Pos = 0;
	CLR  R11
; 0001 0041 
; 0001 0042  for(i=0;i<5;i++)
	LDI  R16,LOW(0)
_0x20011:
	CPI  R16,5
	BRSH _0x20012
; 0001 0043   {
; 0001 0044      while(F_Data_Out == 0);
_0x20013:
	SBRS R2,0
	RJMP _0x20013
; 0001 0045 
; 0001 0046      F_Data_Out=0;
	CLT
	BLD  R2,0
; 0001 0047      key[i]= IR_BTemp;
	RCALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 4,5
	RCALL __EEPROMWRW
; 0001 0048 
; 0001 0049      Led_Blink(i+1, 1);
	MOV  R30,R16
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x2
; 0001 004A      Frame_Pos = 0;
	CLR  R11
; 0001 004B   }
	SUBI R16,-1
	RJMP _0x20011
_0x20012:
; 0001 004C 
; 0001 004D  Led_Blink(10, 2);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _Led_Blink
; 0001 004E }
	RJMP _0x2000001
;
;void f_set_pin(void)
; 0001 0051 {
_f_set_pin:
; 0001 0052  unsigned char i;
; 0001 0053 
; 0001 0054  for(i=0;i<5;i++)
	ST   -Y,R16
;	i -> R16
	LDI  R16,LOW(0)
_0x20017:
	CPI  R16,5
	BRSH _0x20018
; 0001 0055   {
; 0001 0056    if(IR_BTemp==key[i])
	RCALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	RCALL __EEPROMRDW
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x20019
; 0001 0057     {
; 0001 0058      switch(i)
	MOV  R30,R16
; 0001 0059       {
; 0001 005A        case 0: PORTB.4^=1; break; //  A
	CPI  R30,0
	BRNE _0x2001D
	LDI  R26,0
	SBIC 0x18,4
	LDI  R26,1
	RCALL SUBOPT_0x1
	BRNE _0x2001E
	CBI  0x18,4
	RJMP _0x2001F
_0x2001E:
	SBI  0x18,4
_0x2001F:
	RJMP _0x2001C
; 0001 005B        case 1: PORTB.2^=1; break; //  B
_0x2001D:
	CPI  R30,LOW(0x1)
	BRNE _0x20020
	LDI  R26,0
	SBIC 0x18,2
	LDI  R26,1
	RCALL SUBOPT_0x1
	BRNE _0x20021
	CBI  0x18,2
	RJMP _0x20022
_0x20021:
	SBI  0x18,2
_0x20022:
	RJMP _0x2001C
; 0001 005C        case 2: PORTB.0^=1; break; //  C
_0x20020:
	CPI  R30,LOW(0x2)
	BRNE _0x20023
	LDI  R26,0
	SBIC 0x18,0
	LDI  R26,1
	RCALL SUBOPT_0x1
	BRNE _0x20024
	CBI  0x18,0
	RJMP _0x20025
_0x20024:
	SBI  0x18,0
_0x20025:
	RJMP _0x2001C
; 0001 005D 
; 0001 005E        case 3://    A,B,C
_0x20023:
	CPI  R30,LOW(0x3)
	BRNE _0x20026
; 0001 005F          {
; 0001 0060 
; 0001 0061           PORTB.4=1;
	SBI  0x18,4
; 0001 0062           PORTB.2=1;
	SBI  0x18,2
; 0001 0063           PORTB.0=1;
	SBI  0x18,0
; 0001 0064 
; 0001 0065          }break;
	RJMP _0x2001C
; 0001 0066 
; 0001 0067        case 4://  A,B,C
_0x20026:
	CPI  R30,LOW(0x4)
	BRNE _0x2001C
; 0001 0068          {
; 0001 0069           PORTB.4=0;
	CBI  0x18,4
; 0001 006A           PORTB.2=0;
	CBI  0x18,2
; 0001 006B           PORTB.0=0;
	CBI  0x18,0
; 0001 006C          }break;
; 0001 006D 
; 0001 006E 
; 0001 006F       }//switch(i)
_0x2001C:
; 0001 0070 
; 0001 0071      break;
	RJMP _0x20018
; 0001 0072     }
; 0001 0073   }
_0x20019:
	SUBI R16,-1
	RJMP _0x20017
_0x20018:
; 0001 0074 }
_0x2000001:
	LD   R16,Y+
	RET
;#endif
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0001 0079 {
_ext_int0_isr:
	RCALL SUBOPT_0x4
; 0001 007A  unsigned char CurCNT = Get_CNT(); //  
; 0001 007B 
; 0001 007C  switch(Frame_Pos)
	ST   -Y,R16
;	CurCNT -> R16
	RCALL _Get_CNT
	MOV  R16,R30
	MOV  R30,R11
; 0001 007D   {
; 0001 007E    case 0:
	CPI  R30,0
	BRNE _0x20037
; 0001 007F     {
; 0001 0080      Key_Down();
	RCALL _Key_Down
; 0001 0081      Frame_Pos++;
	RJMP _0x20050
; 0001 0082     }break;
; 0001 0083 
; 0001 0084    case 4:
_0x20037:
	CPI  R30,LOW(0x4)
	BRNE _0x20038
; 0001 0085     {
; 0001 0086      //  
; 0001 0087      Hi_Ref = CurCNT + (CurCNT >> 2); //   +1/4
	MOV  R30,R16
	LSR  R30
	LSR  R30
	ADD  R30,R16
	MOV  R9,R30
; 0001 0088      Lo_Ref = CurCNT - (CurCNT >> 2); //    -1/4
	MOV  R30,R16
	LSR  R30
	LSR  R30
	MOV  R26,R30
	MOV  R30,R16
	SUB  R30,R26
	MOV  R8,R30
; 0001 0089      IR_BTemp = 0; //!!!  
	CLR  R4
	CLR  R5
; 0001 008A         //   
; 0001 008B      Frame_Pos=255;
	LDI  R30,LOW(255)
	MOV  R11,R30
; 0001 008C     }break;
	RJMP _0x20036
; 0001 008D 
; 0001 008E    case 255:
_0x20038:
	CPI  R30,LOW(0xFF)
	BRNE _0x2003B
; 0001 008F     {//   
; 0001 0090      IR_BTemp <<=1;
	LSL  R4
	ROL  R5
; 0001 0091      if (CurCNT > Hi_Ref | CurCNT < Lo_Ref) IR_BTemp |= 1; //    - "1"
	MOV  R30,R9
	MOV  R26,R16
	RCALL __GTB12U
	MOV  R0,R30
	MOV  R30,R8
	RCALL __LTB12U
	OR   R30,R0
	BREQ _0x2003A
	LDI  R30,LOW(1)
	OR   R4,R30
; 0001 0092     }break;
_0x2003A:
	RJMP _0x20036
; 0001 0093 
; 0001 0094    default:Frame_Pos++;
_0x2003B:
_0x20050:
	INC  R11
; 0001 0095   }
_0x20036:
; 0001 0096 }
	LD   R16,Y+
	RJMP _0x20051
;
;// Timer 0 output compare A interrupt service routine
;//interrupt [TIM0_COMPA] void timer0_compa_isr(void)
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0001 009C {
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
; 0001 009D  CNT++;  //   
	INC  R10
; 0001 009E }
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Watchdog timeout interrupt service routine
;interrupt [WDT] void wdt_timeout_isr(void)
; 0001 00A2 {
_wdt_timeout_isr:
	RCALL SUBOPT_0x4
; 0001 00A3  WDTCR=0x48;
	LDI  R30,LOW(72)
	OUT  0x21,R30
; 0001 00A4 
; 0001 00A5  if(TOV_Count++ > 50)Rep_Count=0;
	MOV  R30,R6
	INC  R6
	CPI  R30,LOW(0x33)
	BRLO _0x2003C
	CLR  R7
; 0001 00A6 
; 0001 00A7  if (F_Key_Pressed != 0)//     Key_Up()
_0x2003C:
	SBRS R2,1
	RJMP _0x2003D
; 0001 00A8   {
; 0001 00A9    if (TOV_Count > 10 )
	LDI  R30,LOW(10)
	CP   R30,R6
	BRSH _0x2003E
; 0001 00AA     {
; 0001 00AB      Key_Up(); //    (  )
	RCALL _Key_Up
; 0001 00AC      if (Frame_Pos != 0)
	TST  R11
	BREQ _0x2003F
; 0001 00AD       {
; 0001 00AE     //  
; 0001 00AF     //   
; 0001 00B0        LED = 0; //  
	CBI  0x18,3
; 0001 00B1        if (Frame_Pos == 255)
	LDI  R30,LOW(255)
	CP   R30,R11
	BRNE _0x20042
; 0001 00B2        {
; 0001 00B3         F_Data_Out = 1; // -   UART
	SET
	BLD  R2,0
; 0001 00B4         if(Rep_Count++ > 10)Set_Key=1; // -   
	MOV  R30,R7
	INC  R7
	CPI  R30,LOW(0xB)
	BRLO _0x20043
	BLD  R2,2
; 0001 00B5        }
_0x20043:
; 0001 00B6        else  Frame_Pos = 0;
	RJMP _0x20044
_0x20042:
	CLR  R11
; 0001 00B7       }
_0x20044:
; 0001 00B8     }
_0x2003F:
; 0001 00B9   }
_0x2003E:
; 0001 00BA }
_0x2003D:
_0x20051:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Declare your global variables here
;
;void main(void){
; 0001 00BE void main(void){
_main:
; 0001 00BF // Input/Output Ports initialization
; 0001 00C0 // Port B initialization
; 0001 00C1 
; 0001 00C2 PORTB= 0b00100000;
	LDI  R30,LOW(32)
	OUT  0x18,R30
; 0001 00C3 DDRB=  0b00111101;   //0x18;
	LDI  R30,LOW(61)
	OUT  0x17,R30
; 0001 00C4 
; 0001 00C5 // Timer/Counter 0 initialization
; 0001 00C6 // Clock source: System Clock
; 0001 00C7 // Clock value: 1200,000 kHz
; 0001 00C8 // Mode: Normal top=FFh
; 0001 00C9 // OC0A output: Disconnected
; 0001 00CA // OC0B output: Disconnected
; 0001 00CB TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0001 00CC //TCCR0B=0x01;//0x02;
; 0001 00CD TCNT0=0x00;
	OUT  0x32,R30
; 0001 00CE OCR0A=0x7C;
	LDI  R30,LOW(124)
	OUT  0x36,R30
; 0001 00CF OCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0001 00D0 
; 0001 00D1 /*
; 0001 00D2 // Timer/Counter 0 initialization
; 0001 00D3 // Clock source: System Clock
; 0001 00D4 // Clock value: 1200,000 kHz
; 0001 00D5 // Mode: CTC top=OCR0A
; 0001 00D6 // OC0A output: Disconnected
; 0001 00D7 // OC0B output: Disconnected
; 0001 00D8 TCCR0A=0x02;
; 0001 00D9 TCCR0B=0x00;//0x02;
; 0001 00DA TCNT0=0x00;
; 0001 00DB OCR0A=0x0c;
; 0001 00DC OCR0B=0x00;
; 0001 00DD */
; 0001 00DE // External Interrupt(s) initialization
; 0001 00DF // INT0: On
; 0001 00E0 // INT0 Mode: Falling Edge
; 0001 00E1 // Interrupt on any change on pins PCINT0-5: Off
; 0001 00E2 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0001 00E3 GIFR=0x40;
	OUT  0x3A,R30
; 0001 00E4 MCUCR=0x02;// 
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0001 00E5 //MCUCR=0x01;// 
; 0001 00E6 
; 0001 00E7 // Timer/Counter 0 Interrupt(s) initialization
; 0001 00E8 //TIMSK0=0x04; //  compare A interrupt
; 0001 00E9 TIMSK0=0x02;  //overflow interrupt
	OUT  0x39,R30
; 0001 00EA 
; 0001 00EB // Watchdog Timer initialization
; 0001 00EC // Watchdog Timer Prescaler: OSC/2k
; 0001 00ED // Watchdog Timer interrupt: On
; 0001 00EE #pragma optsize-
; 0001 00EF WDTCR=0x18;
	LDI  R30,LOW(24)
	OUT  0x21,R30
; 0001 00F0 WDTCR=0xC8;
	LDI  R30,LOW(200)
	OUT  0x21,R30
; 0001 00F1 #ifdef _OPTIMIZE_SIZE_
; 0001 00F2 #pragma optsize+
; 0001 00F3 #endif
; 0001 00F4 
; 0001 00F5 Frame_Pos = 0;
	CLR  R11
; 0001 00F6 TOV_Count = 0;
	CLR  R6
; 0001 00F7 
; 0001 00F8 // Global enable interrupts
; 0001 00F9 #asm("sei")
	sei
; 0001 00FA LED = 1;
	SBI  0x18,3
; 0001 00FB delay_ms(120);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0001 00FC LED = 0;
	CBI  0x18,3
; 0001 00FD 
; 0001 00FE #if UART_ON == 1
; 0001 00FF stx_init(); //  UART'
	SBI  0x18,4
	SBI  0x17,4
; 0001 0100 stx_char('O');
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x5
; 0001 0101 stx_char('K');
	LDI  R30,LOW(75)
	RCALL SUBOPT_0x5
; 0001 0102 stx_char('!');
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x5
; 0001 0103 #endif
; 0001 0104 
; 0001 0105 while(1)
_0x20049:
; 0001 0106     {
; 0001 0107        //stx_char('*');
; 0001 0108 #if PROG_ON==1
; 0001 0109         if(Set_Key!=0)// 
	SBRS R2,2
	RJMP _0x2004C
; 0001 010A          {
; 0001 010B           Set_Key=0;
	CLT
	BLD  R2,2
; 0001 010C           Rep_Count=0;
	CLR  R7
; 0001 010D           f_set_key();
	RCALL _f_set_key
; 0001 010E          }
; 0001 010F #endif
; 0001 0110         if (F_Data_Out != 0)//  
_0x2004C:
	SBRS R2,0
	RJMP _0x2004D
; 0001 0111          {
; 0001 0112           #if UART_ON == 1
; 0001 0113           stx_char('*');
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5
; 0001 0114           stx_char(IR_BTemp>>8);
	MOV  R30,R5
	RCALL SUBOPT_0x5
; 0001 0115           stx_char(IR_BTemp);
	ST   -Y,R4
	RCALL _stx_char
; 0001 0116           //stx_char(Rep_Count);
; 0001 0117           #endif
; 0001 0118 
; 0001 0119 #if PROG_ON==1
; 0001 011A           f_set_pin();
	RCALL _f_set_pin
; 0001 011B #endif
; 0001 011C 
; 0001 011D           F_Data_Out = 0;
	CLT
	BLD  R2,0
; 0001 011E           Frame_Pos = 0;
	CLR  R11
; 0001 011F          }
; 0001 0120     }
_0x2004D:
	RJMP _0x20049
; 0001 0121 }
_0x2004E:
	RJMP _0x2004E

	.ESEG
_key:
	.BYTE 0xA

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x0:
	__DELAY_USW 245
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(1)
	EOR  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _Led_Blink

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	MOV  R30,R16
	LDI  R26,LOW(_key)
	LDI  R27,HIGH(_key)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	RJMP _stx_char


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x960
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
